# Math

#### Math()
Core/Math.js 13

Math functions.

### Members

#### static constant Cesium.Math.DEGREES_PER_RADIAN : Number
Core/Math.js 420

The number of degrees in a radian.

#### static constant Cesium.Math.EPSILON1 : Number
Core/Math.js 20

0.1

#### static constant Cesium.Math.EPSILON2 : Number
Core/Math.js 27

0.01

#### static constant Cesium.Math.EPSILON3 : Number
Core/Math.js 34

0.001

#### static constant Cesium.Math.EPSILON4 : Number
Core/Math.js 41

0.0001

#### static constant Cesium.Math.EPSILON5 : Number
Core/Math.js 48

0.00001

#### static constant Cesium.Math.EPSILON6 : Number
Core/Math.js 55

0.000001

#### static constant Cesium.Math.EPSILON7 : Number
Core/Math.js 62

0.0000001

#### static constant Cesium.Math.EPSILON8 : Number
Core/Math.js 69

0.00000001

#### static constant Cesium.Math.EPSILON9 : Number
Core/Math.js 76

0.000000001

#### static constant Cesium.Math.EPSILON10 : Number
Core/Math.js 83

0.0000000001

#### static constant Cesium.Math.EPSILON11 : Number
Core/Math.js 90

0.00000000001

#### static constant Cesium.Math.EPSILON12 : Number
Core/Math.js 97

0.000000000001

#### static constant Cesium.Math.EPSILON13 : Number
Core/Math.js 104

0.0000000000001

#### static constant Cesium.Math.EPSILON14 : Number
Core/Math.js 111

0.00000000000001

#### static constant Cesium.Math.EPSILON15 : Number
Core/Math.js 118

0.000000000000001

#### static constant Cesium.Math.EPSILON16 : Number
Core/Math.js 125

0.0000000000000001

#### static constant Cesium.Math.EPSILON17 : Number
Core/Math.js 132

0.00000000000000001

#### static constant Cesium.Math.EPSILON18 : Number
Core/Math.js 139

0.000000000000000001

#### static constant Cesium.Math.EPSILON19 : Number
Core/Math.js 146

0.0000000000000000001

#### static constant Cesium.Math.EPSILON20 : Number
Core/Math.js 153

0.00000000000000000001

#### static constant Cesium.Math.EPSILON21 : Number
Core/Math.js 160

0.000000000000000000001

#### static constant Cesium.Math.FOUR_GIGABYTES : Number
Core/Math.js 198

4 * 1024 * 1024 * 1024

#### static constant Cesium.Math.GRAVITATIONALPARAMETER : Number
Core/Math.js 168

The gravitational parameter of the Earth in meters cubed per second squared as defined by the WGS84 model: 3.986004418e14

#### static constant Cesium.Math.LUNAR_RADIUS : Number
Core/Math.js 184

The mean radius of the moon, according to the "Report of the IAU/IAG Working Group on Cartographic Coordinates and Rotational Elements of the Planets and satellites: 2000", Celestial Mechanics 82: 83-110, 2002.

#### static constant Cesium.Math.ONE_OVER_PI : Number
Core/Math.js 348

1/pi

#### static constant Cesium.Math.ONE_OVER_TWO_PI : Number
Core/Math.js 404

1/2pi

#### static constant Cesium.Math.PI : Number
Core/Math.js 340

pi

#### static constant Cesium.Math.PI_OVER_FOUR : Number
Core/Math.js 372

pi/4

#### static constant Cesium.Math.PI_OVER_SIX : Number
Core/Math.js 380

pi/6

#### static constant Cesium.Math.PI_OVER_THREE : Number
Core/Math.js 364

pi/3

#### static constant Cesium.Math.PI_OVER_TWO : Number
Core/Math.js 356

pi/2

#### static constant Cesium.Math.RADIANS_PER_ARCSECOND : Number
Core/Math.js 428

The number of radians in an arc second.

#### static constant Cesium.Math.RADIANS_PER_DEGREE : Number
Core/Math.js 412

The number of radians in a degree.

#### static constant Cesium.Math.SIXTY_FOUR_KILOBYTES : Number
Core/Math.js 191

64 * 1024

#### static constant Cesium.Math.SOLAR_RADIUS : Number
Core/Math.js 175

Radius of the sun in meters: 6.955e8

#### static constant Cesium.Math.THREE_PI_OVER_TWO : Number
Core/Math.js 388

3pi/2

#### static constant Cesium.Math.TWO_PI : Number
Core/Math.js 396

2pi

### Methods

#### static Cesium.Math.acosClamped(value) → Number
Core/Math.js 947

Computes `Math.acos(value)`, but first clamps `value` to the range [-1.0, 1.0] so that the function will never return NaN.

Name | Type | Description
--- | --- | ---
`value` | Number | The value for which to compute acos.

##### Returns:

The acos of the value if the value is in the range [-1.0, 1.0], or the acos of -1.0 or 1.0, whichever is closer, if the value is outside the range.

#### static Cesium.Math.asinClamped(value) → Number
Core/Math.js 964

Computes `Math.asin(value)`, but first clamps `value` to the range [-1.0, 1.0] so that the function will never return NaN.

Name | Type | Description
--- | --- | ---
`value` | Number | The value for which to compute asin.

##### Returns:

The asin of the value if the value is in the range [-1.0, 1.0], or the asin of -1.0 or 1.0, whichever is closer, if the value is outside the range.

#### static Cesium.Math.cbrt(number) → Number
Core/Math.js 1020

Finds the cube root of a number. Returns NaN if `number` is not provided.

Name | Type | Description
--- | --- | ---
`number` | Number | optional The number.

##### Returns:

The result.

#### static Cesium.Math.chordLength(angle, radius) → Number
Core/Math.js 980

Finds the chord length between two points given the circle's radius and the angle between the points.

Name | Type | Description
--- | --- | ---
`angle` | Number | The angle between the two points.
`radius` | Number | The radius of the circle.

##### Returns:

The chord length.

#### static Cesium.Math.clamp(value, min, max) → Number
Core/Math.js 882

Constraint a value to lie between two values.

Name | Type | Description
--- | --- | ---
`value` | Number | The value to constrain.
`min` | Number | The minimum value.
`max` | Number | The maximum value.

##### Returns:

The value clamped so that min <= value <= max.

#### static Cesium.Math.clampToLatitudeRange(angle) → Number
Core/Math.js 499

Convenience function that clamps a latitude value, in radians, to the range [`-Math.PI/2`, `Math.PI/2`). Useful for sanitizing data before use in objects requiring correct range.

Name | Type | Description
--- | --- | ---
`angle` | Number | The latitude value, in radians, to clamp to the range [`-Math.PI/2`, `Math.PI/2`).

##### Returns:

The latitude value clamped to the range [`-Math.PI/2`, `Math.PI/2`).

##### Example:

    // Clamp 108 degrees latitude to 90 degrees latitude
    var latitude = Cesium.Math.clampToLatitudeRange(Cesium.Math.toRadians(108.0));

#### static Cesium.Math.convertLongitudeRange(angle) → Number
Core/Math.js 468

Converts a longitude value, in radians, to the range [`-Math.PI`, `Math.PI`).

Name | Type | Description
--- | --- | ---
`angle` | Number | The longitude value, in radians, to convert to the range [`-Math.PI`, `Math.PI`).

##### Returns:

The equivalent longitude value in the range [`-Math.PI`, `Math.PI`).

##### Example:

    // Convert 270 degrees to -90 degrees longitude
    var longitude = Cesium.Math.convertLongitudeRange(Cesium.Math.toRadians(270.0));

#### static Cesium.Math.cosh(value) → Number
Core/Math.js 315

Returns the hyperbolic cosine of a number. The hyperbolic cosine of value is defined to be (ex + e-x)/2.0 where e is Euler's number, approximately 2.71828183.

Special cases:

- If the argument is NaN, then the result is NaN.
- If the argument is infinite, then the result is positive infinity.
- If the argument is zero, then the result is 1.0.

Name | Type | Description
--- | --- | ---
`value` | Number | The number whose hyperbolic cosine is to be returned.

##### Returns:

The hyperbolic cosine of `value`.

#### static Cesium.Math.equalsEpsilon(left, right, relativeEpsilon, absoluteEpsilon) → Boolean
Core/Math.js 599

Determines if two values are equal using an absolute or relative tolerance test. This is useful to avoid problems due to roundoff error when comparing floating-point values directly. The values are first compared using an absolute tolerance test. If that fails, a relative tolerance test is performed. Use this test if you are unsure of the magnitudes of left and right.

Name | Type | Default | Description
--- | --- | --- | ---
`left` | Number |  | The first value to compare.
`right` | Number |  | The other value to compare.
`relativeEpsilon` | Number | `0` | optional The maximum inclusive delta between `left` and `right` for the relative tolerance test.
`absoluteEpsilon` | Number | `relativeEpsilon` | optional The maximum inclusive delta between `left` and `right` for the absolute tolerance test.

##### Returns:

`true` if the values are equal within the epsilon; otherwise, `false`.

##### Example:

    var a = Cesium.Math.equalsEpsilon(0.0, 0.01, Cesium.Math.EPSILON2); // true
    var b = Cesium.Math.equalsEpsilon(0.0, 0.1, Cesium.Math.EPSILON2);  // false
    var c = Cesium.Math.equalsEpsilon(3699175.1634344, 3699175.2, Cesium.Math.EPSILON7); // true
    var d = Cesium.Math.equalsEpsilon(3699175.1634344, 3699175.2, Cesium.Math.EPSILON9); // false

#### static Cesium.Math.factorial(n) → Number
Core/Math.js 734

Computes the factorial of the provided number.

Name | Type | Description
--- | --- | ---
`n` | Number | The number whose factorial is to be computed.

##### Returns:

The factorial of the provided number or undefined if the number is less than 0.

##### Throws:

- DeveloperError : A number greater than or equal to 0 is required.

##### Example:

    //Compute 7!, which is equal to 5040
    var computedFactorial = Cesium.Math.factorial(7);

##### See:

- Factorial on Wikipedia

#### static Cesium.Math.fastApproximateAtan(x) → Number
Core/Math.js 1056

Computes a fast approximation of Atan for input in the range [-1, 1]. Based on Michal Drobot's approximation from ShaderFastLibs, which in turn is based on "Efficient approximations for the arctangent function," Rajan, S. Sichun Wang Inkol, R. Joyal, A., May 2006. Adapted from ShaderFastLibs under MIT License.

Name | Type | Description
--- | --- | ---
`x` | Number | An input number in the range [-1, 1]

##### Returns:

An approximation of atan(x)

#### static Cesium.Math.fastApproximateAtan2(x, y) → Number
Core/Math.js 1073

Computes a fast approximation of Atan2(x, y) for arbitrary input scalars. Range reduction math based on nvidia's cg reference implementation: http://developer.download.nvidia.com/cg/atan2.html

Name | Type | Description
--- | --- | ---
`x` | Number | An input number that isn't zero if y is zero.
`y` | Number | An input number that isn't zero if x is zero.

##### Returns:

An approximation of atan2(x, y)

#### static Cesium.Math.fromSNorm(value, rangeMaximum) → Number
Core/Math.js 250

Converts a SNORM value in the range [0, rangeMaximum] to a scalar in the range [-1.0, 1.0].

Name | Type | Default | Description
--- | --- | --- | ---
`value` | Number |  | SNORM value in the range [0, rangeMaximum]
`rangeMaximum` | Number | `255` | optional The maximum value in the SNORM range, 255 by default.

##### Returns:

Scalar in the range [-1.0, 1.0].

##### See:

- CesiumMath.toSNorm

#### static Cesium.Math.greaterThan(left, right, absoluteEpsilon) → Boolean
Core/Math.js 677

Determines if the left value is greater the right value. If the two values are within `absoluteEpsilon` of each other, they are considered equal and this function returns false.

Name | Type | Description
--- | --- | ---
`left` | Number | The first number to compare.
`right` | Number | The second number to compare.
`absoluteEpsilon` | Number | The absolute epsilon to use in comparison.

##### Returns:

`true` if `left` is greater than `right` by more than `absoluteEpsilon`. `false` if `left` is less or if the two values are nearly equal.``

#### static Cesium.Math.greaterThanOrEquals(left, right, absoluteEpsilon) → Boolean
Core/Math.js 702

Determines if the left value is greater than or equal to the right value. If the two values are within `absoluteEpsilon` of each other, they are considered equal and this function returns true.

Name | Type | Description
--- | --- | ---
`left` | Number | The first number to compare.
`right` | Number | The second number to compare.
`absoluteEpsilon` | Number | The absolute epsilon to use in comparison.

##### Returns:

`true` if `left` is greater than `right` or if the the values are nearly equal.

#### static Cesium.Math.incrementWrap(n, maximumValue, minimumValue) → Number
Core/Math.js 767

Increments a number with a wrapping to a minimum value if the number exceeds the maximum value.

Name | Type | Default | Description
--- | --- | --- | ---
`n` | Number |  | optional The number to be incremented.
`maximumValue` | Number |  | optional The maximum incremented value before rolling over to the minimum value.
`minimumValue` | Number | `0.0` | optional The number reset to after the maximum value has been exceeded.

##### Returns:

The incremented number.

##### Throws:

- DeveloperError : Maximum value must be greater than minimum value.

##### Example:

    var n = Cesium.Math.incrementWrap(5, 10, 0); // returns 6
    var n = Cesium.Math.incrementWrap(10, 10, 0); // returns 0

#### static Cesium.Math.isPowerOfTwo(n) → Boolean
Core/Math.js 799

Determines if a non-negative integer is a power of two. The maximum allowed input is (2^32)-1 due to 32-bit bitwise operator limitation in Javascript.

Name | Type | Description
--- | --- | ---
`n` | Number | The integer to test in the range [0, (2^32)-1].

##### Returns:

`true` if the number if a power of two; otherwise, `false`.

##### Throws:

- DeveloperError : A number between 0 and (2^32)-1 is required.

##### Example:

    var t = Cesium.Math.isPowerOfTwo(16); // true
    var f = Cesium.Math.isPowerOfTwo(20); // false

#### static Cesium.Math.lerp(p, q, time) → Number
Core/Math.js 330

Computes the linear interpolation of two values.

Name | Type | Description
--- | --- | ---
`p` | Number | The start value to interpolate.
`q` | Number | The end value to interpolate.
`time` | Number | The time of interpolation generally in the range `[0.0, 1.0]`.

##### Returns:

The linearly interpolated value.

##### Example:

    var n = Cesium.Math.lerp(0.0, 2.0, 0.5); // returns 1.0

#### static Cesium.Math.lessThan(left, right, absoluteEpsilon) → Boolean
Core/Math.js 626

Determines if the left value is less than the right value. If the two values are within `absoluteEpsilon` of each other, they are considered equal and this function returns false.

Name | Type | Description
--- | --- | ---
`left` | Number | The first number to compare.
`right` | Number | The second number to compare.
`absoluteEpsilon` | Number | The absolute epsilon to use in comparison.

##### Returns:

`true` if `left` is less than `right` by more than `absoluteEpsilon`. `false` if `left` is greater or if the two values are nearly equal.``

#### static Cesium.Math.lessThanOrEquals(left, right, absoluteEpsilon) → Boolean
Core/Math.js 651

Determines if the left value is less than or equal to the right value. If the two values are within `absoluteEpsilon` of each other, they are considered equal and this function returns true.

Name | Type | Description
--- | --- | ---
`left` | Number | The first number to compare.
`right` | Number | The second number to compare.
`absoluteEpsilon` | Number | The absolute epsilon to use in comparison.

##### Returns:

`true` if `left` is less than `right` or if the the values are nearly equal.

#### static Cesium.Math.log2(number) → Number
Core/Math.js 1033

Finds the base 2 logarithm of a number.

Name | Type | Description
--- | --- | ---
`number` | Number | The number.

##### Returns:

The result.

#### static Cesium.Math.logBase(number, base) → Number
Core/Math.js 999

Finds the logarithm of a number to a base.

Name | Type | Description
--- | --- | ---
`number` | Number | The number.
`base` | Number | The base.

##### Returns:

The result.

#### static Cesium.Math.mod(m, n) → Number
Core/Math.js 560

The modulo operation that also works for negative dividends.

Name | Type | Description
--- | --- | ---
`m` | Number | The dividend.
`n` | Number | The divisor.

##### Returns:

The remainder.

#### static Cesium.Math.negativePiToPi(angle) → Number
Core/Math.js 515

Produces an angle in the range -Pi <= angle <= Pi which is equivalent to the provided angle.

Name | Type | Description
--- | --- | ---
`angle` | Number | in radians

##### Returns:

The angle in the range [`-CesiumMath.PI`, `CesiumMath.PI`].

#### static Cesium.Math.nextPowerOfTwo(n) → Number
Core/Math.js 822

Computes the next power-of-two integer greater than or equal to the provided non-negative integer. The maximum allowed input is 2^31 due to 32-bit bitwise operator limitation in Javascript.

Name | Type | Description
--- | --- | ---
`n` | Number | The integer to test in the range [0, 2^31].

##### Returns:

The next power-of-two integer.

##### Throws:

- DeveloperError : A number between 0 and 2^31 is required.

##### Example:

    var n = Cesium.Math.nextPowerOfTwo(29); // 32
    var m = Cesium.Math.nextPowerOfTwo(32); // 32

#### static Cesium.Math.nextRandomNumber() → Number
Core/Math.js 924

Generates a random floating point number in the range of [0.0, 1.0) using a Mersenne twister.

##### Returns:

A random number in the range of [0.0, 1.0).

##### See:

- CesiumMath.setRandomNumberSeed
- Mersenne twister on Wikipedia

#### static Cesium.Math.normalize(value, rangeMinimum, rangeMaximum) → Number
Core/Math.js 262

Converts a scalar value in the range [rangeMinimum, rangeMaximum] to a scalar in the range [0.0, 1.0]

Name | Type | Description
--- | --- | ---
`value` | Number | The scalar value in the range [rangeMinimum, rangeMaximum]
`rangeMinimum` | Number | The minimum value in the mapped range.
`rangeMaximum` | Number | The maximum value in the mapped range.

##### Returns:

A scalar value, where rangeMinimum maps to 0.0 and rangeMaximum maps to 1.0.

#### static Cesium.Math.previousPowerOfTwo(n) → Number
Core/Math.js 854

Computes the previous power-of-two integer less than or equal to the provided non-negative integer. The maximum allowed input is (2^32)-1 due to 32-bit bitwise operator limitation in Javascript.

Name | Type | Description
--- | --- | ---
`n` | Number | The integer to test in the range [0, (2^32)-1].

##### Returns:

The previous power-of-two integer.

##### Throws:

- DeveloperError : A number between 0 and (2^32)-1 is required.

##### Example:

    var n = Cesium.Math.previousPowerOfTwo(29); // 16
    var m = Cesium.Math.previousPowerOfTwo(32); // 32

#### static Cesium.Math.randomBetween(min, max) → Number
Core/Math.js 935

Generates a random number between two numbers.

Name | Type | Description
--- | --- | ---
`min` | Number | The minimum value.
`max` | Number | The maximum value.

##### Returns:

A random number between the min and max.

#### static Cesium.Math.setRandomNumberSeed(seed)
Core/Math.js 905

Sets the seed used by the random number generator in `CesiumMath#nextRandomNumber`.

Name | Type | Description
--- | --- | ---
`seed` | Number | An integer used as the seed.

#### static Cesium.Math.sign(value) → Number
Core/Math.js 209

Returns the sign of the value; 1 if the value is positive, -1 if the value is negative, or 0 if the value is 0.

Name | Type | Description
--- | --- | ---
`value` | Number | The value to return the sign of.

##### Returns:

The sign of value.

#### static Cesium.Math.signNotZero(value) → Number
Core/Math.js 225

Returns 1.0 if the given value is positive or zero, and -1.0 if it is negative. This is similar to `CesiumMath#sign` except that returns 1.0 instead of 0.0 when the input value is 0.0.

Name | Type | Description
--- | --- | ---
`value` | Number | The value to return the sign of.

##### Returns:

The sign of value.

#### static Cesium.Math.sinh(value) → Number
Core/Math.js 290

Returns the hyperbolic sine of a number. The hyperbolic sine of value is defined to be (ex - e-x)/2.0 where e is Euler's number, approximately 2.71828183.

Special cases:

- If the argument is NaN, then the result is NaN.
- If the argument is infinite, then the result is an infinity with the same sign as the argument.
- If the argument is zero, then the result is a zero with the same sign as the argument.

Name | Type | Description
--- | --- | ---
`value` | Number | The number whose hyperbolic sine is to be returned.

##### Returns:

The hyperbolic sine of `value`.

#### static Cesium.Math.toDegrees(radians) → Number
Core/Math.js 449

Converts radians to degrees.

Name | Type | Description
--- | --- | ---
`radians` | Number | The angle to convert in radians.

##### Returns:

The corresponding angle in degrees.

#### static Cesium.Math.toRadians(degrees) → Number
Core/Math.js 435

Converts degrees to radians.

Name | Type | Description
--- | --- | ---
`degrees` | Number | The angle to convert in degrees.

##### Returns:

The corresponding angle in radians.

#### static Cesium.Math.toSNorm(value, rangeMaximum) → Number
Core/Math.js 237

Converts a scalar value in the range [-1.0, 1.0] to a SNORM in the range [0, rangeMaximum]

Name | Type | Default | Description
--- | --- | --- | ---
`value` | Number |  | The scalar value in the range [-1.0, 1.0]
`rangeMaximum` | Number | `255` | optional The maximum value in the mapped range, 255 by default.

##### Returns:

A SNORM value, where 0 maps to -1.0 and rangeMaximum maps to 1.0.

##### See:

- CesiumMath.fromSNorm

#### static Cesium.Math.zeroToTwoPi(angle) → Number
Core/Math.js 535

Produces an angle in the range 0 <= angle <= 2Pi which is equivalent to the provided angle.

Name | Type | Description
--- | --- | ---
`angle` | Number | in radians

##### Returns:

The angle in the range [0, `CesiumMath.TWO_PI`].